
#define _LARGEFILE_SOURCE 
#define _LARGEFILE64_SOURCE

#include <stdio.h>
#include <stdint.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>

#define BUF_SIZE 1<<15
//#define BUF_SIZE 4

int main(int argc, char *argv[]) {
  unsigned char buf[BUF_SIZE];
  int fd;
  unsigned int i;
  int n;
  uint64_t *count;
  int padd = 0;

  count = (uint64_t*) malloc(sizeof(uint64_t) * (1<<16));
  if(count == NULL) {
    perror("malloc");
    return 1;
  }

  if(argc <= 1 || (argc == 2 && strcmp(argv[1], "-") == 0 ) )
    fd = 0;
  else {
    fd = open(argv[1], O_RDONLY | O_LARGEFILE);
    if(fd == -1) {
      perror("open");
      return 1;
    }
  }

  while( (n = read(fd, buf + padd, sizeof(buf) - padd)) > 0 ) {
    
    /* n = nb bytes in the buffer */
    n += padd;
    
#define METHOD 2

#if ( METHOD == 1 )
# warning ======================= HINT ===========================
# warning ======
# warning ====== METHOD 1 SELECTED FOR EXTRACTION OF VALUES
# warning ====== (METHOD 2 SHOULD GIVE BETTER PERFORMANCES)
# warning ====== 
    for(i = 0; i < (unsigned int)n - 1; i++) {
      uint16_t tmp;
      
      memcpy(&tmp, buf+i, 2);
      
      count[tmp]++;
    }
#elif ( METHOD == 2 )
# warning ======================= HINT ===========================
# warning ======
# warning ====== METHOD 2 SELECTED FOR EXTRACTION OF VALUES
# warning ====== (THIS SHOULD GIVE THE BEST PERFORMANCES)
# warning ====== 
    register uint16_t tmp;

    tmp = (uint16_t) buf[0];
    for(i = 0; i < (unsigned int)n - 1; i++) {
      
      tmp = (tmp << 8) + (uint16_t)buf[i+1];      
      count[tmp]++;
    }
#endif
    
    buf[0] = buf[n-1];
    padd = 1;
  }

  if(n == -1) {
    perror("read");
    return 2;
  }
  close(fd);
  
  for(i = 0; i < (1<<16); i++)
    printf("%d %llu\n", i, count[i]);

  return 0;  
}
