#!/bin/sh

FILE="$1"

TMPFILE=$(mktemp /tmp/histoXXXXXX)
TMPSCRIPT=$(mktemp /tmp/histo.gnuplot.XXXXXX)

$(dirname $0)/word_distrib "$FILE" > "$TMPFILE"

cat << EOF > "$TMPSCRIPT"
 #set palette gray
 #set style fill solid 0.0
 set style fill solid 1.0
 set boxwidth 0.5

 set mouse
 #set mouse mouseformat

 plot [-10:65600][0:] "$TMPFILE" using 1:2 with boxes 
 pause mouse

 if (defined(MOUSE_X)) print int(MOUSE_X); \
 else print "No mouse click."

 reread
EOF

gnuplot "$TMPSCRIPT"

rm -f -- "$TMPFILE" "$TMPSCRIPT"
