#!/bin/sh

FILE="$1"

TMPFILE=$(mktemp /tmp/histoXXXXXX)
TMPSCRIPT=$(mktemp /tmp/histo.gnuplot.XXXXXX)

od -A n -t u1 "$FILE" | tr -s "[[:space:]]" "\n" | grep -v "^[[:space:]]*$" | sort | uniq -c > $TMPFILE

cat << EOF > "$TMPSCRIPT"
 #set palette gray
 #set style fill solid 0.0
 set style fill solid 1.0
 set boxwidth 0.5

 #set mouse verbose
 #set mouse mouseformat

 plot [-10:265][0:] "$TMPFILE" using 2:1 with boxes 
 pause mouse
EOF

gnuplot "$TMPSCRIPT"

rm -f -- "$TMPFILE" "$TMPSCRIPT"
